package com.cico.nest.lcdp.boot.core.qxsd.application.service;

import java.util.*;
import jakarta.validation.*;
import com.cico.nest.lcdp.boot.core.qxsd.adapter.web.vo.tunnelBase.*;
import com.cico.nest.lcdp.boot.core.qxsd.infrastructure.gatewayimpl.database.dataobject.TunnelBaseDO;
import com.cico.nest.lcdp.framework.common.pojo.PageResult;
import com.cico.nest.lcdp.framework.common.pojo.PageParam;

/**
 * 隧道设施基础信息 Service 接口
 *
 * @author 管理员
 */
public interface TunnelBaseService {

    /**
     * 创建隧道设施信息
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    String createTunnel(@Valid TunnelInfoVo createReqVO);

    /**
     * 创建隧道设施基础信息
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    String createTunnelBase(@Valid TunnelBaseSaveReqVO createReqVO);

    /**
     * 更新隧道设施信息
     *
     * @param updateReqVO 更新信息
     */
    void updateTunnel(@Valid TunnelInfoVo updateReqVO);

    /**
     * 更新隧道设施基础信息
     *
     * @param updateReqVO 更新信息
     */
    void updateTunnelBase(@Valid TunnelBaseSaveReqVO updateReqVO);

    /**
     * 删除隧道设施信息
     *
     * @param id 编号
     */
    void deleteTunnel(String id);

    /**
     * 删除隧道设施基础信息
     *
     * @param id 编号
     */
    void deleteTunnelBase(String id);

    /**
     * 获得隧道设施基础信息
     *
     * @param id 编号
     * @return 隧道设施基础信息
     */
    TunnelBaseDO getTunnelBase(String id);

    /**
     * 获得隧道设施基础信息分页
     *
     * @param pageReqVO 分页查询
     * @return 隧道设施基础信息分页
     */
    PageResult<TunnelBaseDO> getTunnelBasePage(TunnelBasePageReqVO pageReqVO);

    /**
     * 页面设施详情
     * @param id
     * @return
     */
    TunnelInfoVo getTunnel(String id);
    /**
     * 启用设施
     * @param id 设施id
     * @return
     */
    void enable(String id);
    /**
     * 禁用设施
     * @param id 设施id
     * @return
     */
    void disEnable(String id);

    /**
     * 启用的设施列表
     * @param deptId 组织id
     * @return
     */
    List<TunnelBaseRespVO> getEnableList(String deptId);
    /**
     * 获得隧道设施信息分页
     *
     * @param pageReqVO 分页查询
     * @return 隧道设施基础信息分页
     */
    PageResult<TunnelBaseRespVO> getTunnelPage(@Valid TunnelBasePageReqVO pageReqVO);


    /**
     * 获取隧道列表
     * @param tunnelIds 隧道ids
     * @param sfIds     第三方的隧道ids
     * @return
     */
    List<TunnelBaseDO> getByIds(List<String> tunnelIds,List<String> sfIds);
}
